Links

‌‌
This endpoint will provide you with a list of internal and external links detected on a target website.
The following link types are supported:
anchor – links that point to a specific portion of a webpage;
image – links that point to an image;
canonical – links that point to a canonical page;
meta – links with meta http-equiv=refresh ;
alternate – links with link rel="alternate" pointing to an alternative version of a webpage ;
redirect – links with redirect status.

checked POST
Pricing

Your account will not be charged for using this function. You can get the results of the task within the next 30 days for free.
The cost can be calculated on the Pricing page.

All POST data should be sent in the JSON format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array.

Description of the fields for setting a task:

Field nameTypeDescription
idstring

ID of the task
required field
you can get this ID in the response of the Task POST endpoint
example:
"07131248-1535-0216-1000-17384017ad04"

page_fromstring

relative page URL
optional field
if you use this field, the API response will contain only links from the specified page
note that in this field you can specify relative URLs only

page_tostring

relative page URL
optional field
if you use this field, the API response will contain only internal links pointing to the specified page
note that in this field you can specify relative URLs only

limitinteger

the maximum number of returned links
optional field
default value: 100
maximum value: 1000

offsetinteger

offset in the results array of returned links
optional field
default value: 0
maximum value: 2000000
if you specify the 10 value, the first ten links in the results array will be omitted and the data will be provided for the successive links

filtersarray

array of results filtering parameters
optional field
you can add several filters at once (8 filters maximum)
you should set a logical operator and, or between the conditions
the following operators are supported:
regex, not_regex, =, <>, in, not_in, like, not_like
you can use the % operator with like and not_like to match any string of zero or more characters
example:
["direction","=","external"]

[["domain_to","<>","example.com"],
"and",
["link_from","not_like","%example.com/blog%"]]

[["direction","=","external"],
"and",
[["link_from","like","%example.com/blog%"],"or",["link_from","like","%example.com/help%"]]]

The full list of possible filters is available by this link.

search_after_tokenstring

token for subsequent requests
optional field
provided in the identical filed of the response to each request;
use this parameter to avoid timeouts while trying to obtain over 20,000 results in a single request;
by specifying the unique search_after_token value from the response array, you will get the subsequent results of the initial task;
search_after_token values are unique for each subsequent task ;
Note: if the search_after_token is specified in the request, all other parameters should be identical to the previous request

tagstring

user-defined task identifier
optional field
the character limit is 255
you can use this parameter to identify the task and match it with the result
you will find the specified tag value in the data object of the response


‌‌‌‌‌‌
As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.

Description of the fields in the results array:

Field nameTypeDescription
versionstring

the current version of the API

status_codeinteger

general status code
you can find the full list of the response codes here
Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions

status_messagestring

general informational message
you can find the full list of general informational messages here

timestring

execution time, seconds

costfloat

total tasks cost, USD

tasks_countinteger

the number of tasks in the tasks array

tasks_errorinteger

the number of tasks in the tasks array returned with an error

tasksarray

array of tasks

    idstring

task identifier
unique task identifier in our system in the UUID format

    status_codeinteger

status code of the task
generated by DataForSEO; can be within the following range: 10000-60000
you can find the full list of the response codes here

    status_messagestring

informational message of the task
you can find the full list of general informational messages here

    timestring

execution time, seconds

    costfloat

cost of the task, USD

    result_countinteger

number of elements in the result array

    patharray

URL path

    dataobject

contains the same parameters that you specified in the POST request

    resultarray

array of results

        crawl_progressstring

status of the crawling session
possible values: in_progress, finished

        crawl_statusobject

details of the crawling session

            max_crawl_pagesinteger

maximum number of pages to crawl
indicates the max_crawl_pages limit you specified when setting a task

            pages_in_queueinteger

number of pages that are currently in the crawling queue

            pages_crawledinteger

number of crawled pages

        total_items_countinteger

total number of relevant items in the database

        items_countinteger

number of items in the results array

        itemsarray

items array

            anchor_linkobject
            typestring

type of the link = 'anchor'
tag

            domain_fromstring

referring domain
the link was found on this domain

            domain_tostring

referenced domain
the link is pointing to this domain

            page_fromstring

referring page
relative URL of the page on which the link was found

            page_tostring

referenced page
relative URL of the page to which the link is pointing

            link_fromstring

referring page
absolute URL of the page on which the link was found

            link_tostring

referenced page
absolute URL of the page to which the link is pointing

            link_attributearray

link attribute added to external link
indicates link attributes added to the link_to on the page_from
example:
["ugc","noopener"]

            dofollowboolean

indicates whether the link is dofollow
if the value is true, the link doesn't have a rel="nofollow" attribute

            page_from_schemestring

url scheme of the referring page

            page_to_schemestring

url scheme of the referenced page

            directionstring

direction of the link
possible values: internal, external

            is_brokenboolean

link is broken
indicates whether a link is directing to a broken page or resource

            textstring

anchor text

            is_link_relation_conflictboolean

indicates that the link may have a conflict with another link
if true, at least one link pointing to link_to has a rel="nofollow" attribute and at least one is dofollow

            page_to_status_codeinteger

status code of the referenced page
status code of the page to which the link is pointing

            image_linkobject
            typestring

type of the link = 'image'
tag contained in the tag

            domain_fromstring

referring domain
the link was found on this domain

            domain_tostring

referenced domain
the link is pointing to this domain

            page_fromstring

referring page
relative URL of the page on which the link was found

            page_tostring

referenced page
relative URL of the page to which the link is pointing

            link_fromstring

referring page
absolute URL of the page on which the link was found

            link_tostring

referenced page
absolute URL of the page to which the link is pointing

            link_attributearray

link attribute added to external link
indicates link attributes added to the link_to on the page_from
["ugc","noopener"]

            dofollowboolean

indicates whether the link is dofollow
if the value is true, the link doesn't have a rel="nofollow" attribute

            page_from_schemestring

url scheme of the referring page

            page_to_schemestring

url scheme of the referenced page

            directionstring

direction of the link
possible values: internal, external

            is_brokenboolean

link is broken
indicates whether a link is directing to a broken page or resource

            textstring

image text

            image_altstring

alternative text for the image

            image_srcstring

url of the image

            is_link_relation_conflictboolean

indicates that the link may have a conflict with another link
if true, at least one link pointing to link_to has a rel="nofollow" attribute and at least one is dofollow

            page_to_status_codeinteger

status code of the referenced page
status code of the page to which the link is pointing

            link_tag_linkobject
            typestring

type of the link = 'link'
tag

            domain_fromstring

referring domain
the link was found on this domain

            domain_tostring

referenced domain
the link is pointing to this domain

            page_fromstring

referring page
relative URL of the page on which the link was found

            page_tostring

referenced page
relative URL of the page to which the link is pointing

            link_fromstring

referring page
absolute URL of the page on which the link was found

            link_tostring

referenced page
absolute URL of the page to which the link is pointing

            dofollowboolean

indicates whether the link is dofollow
if the value is true, the link doesn't have a rel="nofollow" attribute

            page_from_schemestring

url scheme of the referring page

            page_to_schemestring

url scheme of the referenced page

            directionstring

direction of the link
possible values: internal, external

            is_brokenboolean

link is broken
indicates whether a link is directing to a broken page or resource

            is_link_relation_conflictboolean

indicates that the link may have a conflict with another link
if true, at least one link pointing to link_to has a rel="nofollow" attribute and at least one is dofollow

            page_to_status_codeinteger

status code of the referenced page
status code of the page to which the link is pointing

            canonical_linkobject
            typestring

type of the link = 'canonical'
tag

            domain_fromstring

referring domain
the link was found on this domain

            domain_tostring

referenced domain
the link is pointing to this domain

            page_fromstring

referring page
relative URL of the page on which the link was found

            page_tostring

referenced page
relative URL of the page to which the link is pointing

            link_fromstring

referring page
absolute URL of the page on which the link was found

            link_tostring

referenced page
absolute URL of the page to which the link is pointing

            dofollowboolean

indicates whether the link is dofollow
if the value is true, the link doesn't have a rel="nofollow" attribute

            page_from_schemestring

url scheme of the referring page

            page_to_schemestring

url scheme of the referenced page

            directionstring

direction of the link
possible values: internal, external

            is_brokenboolean

link is broken
indicates whether a link is directing to a broken page or resource

            is_link_relation_conflictboolean

indicates that the link may have a conflict with another link
if true, at least one link pointing to link_to has a rel="nofollow" attribute and at least one is dofollow

            page_to_status_codeinteger

status code of the referenced page
status code of the page to which the link is pointing

            meta_linkobject
            typestring

type of the link = 'meta'
https://wikipedia.org">; tag

            domain_fromstring

referring domain
the link was found on this domain

            domain_tostring

referenced domain
the link is pointing to this domain

            page_fromstring

referring page
relative URL of the page on which the link was found

            page_tostring

referenced page
relative URL of the page to which the link is pointing

            link_fromstring

referring page
absolute URL of the page on which the link was found

            link_tostring

referenced page
absolute URL of the page to which the link is pointing

            dofollowboolean

indicates whether the link is dofollow
if the value is true, the link doesn't have a rel="nofollow" attribute

            page_from_schemestring

url scheme of the referring page

            page_to_schemestring

url scheme of the referenced page

            directionstring

direction of the link
possible values: internal, external

            is_brokenboolean

link is broken
indicates whether a link is directing to a broken page or resource

            is_link_relation_conflictboolean

indicates that the link may have a conflict with another link
if true, at least one link pointing to link_to has a rel="nofollow" attribute and at least one is dofollow

            page_to_status_codeinteger

status code of the referenced page
status code of the page to which the link is pointing

            alternate_linkobject
            typestring

type of the link = 'alternate'
tag

            is_valid_hreflangboolean

hreflang validity status
indicates whether the hreflang attribute is correctly implemented

            hreflangstring

hreflang attribute value
language and optional country code specified in the hreflang attribute
example: "en-US", "fr"

            domain_fromstring

referring domain
the link was found on this domain

            domain_tostring

referenced domain
the link is pointing to this domain

            page_fromstring

referring page
relative URL of the page on which the link was found

            page_tostring

referenced page
relative URL of the page to which the link is pointing

            link_fromstring

referring page
absolute URL of the page on which the link was found

            link_tostring

referenced page
absolute URL of the page to which the link is pointing

            dofollowboolean

indicates whether the link is dofollow
if the value is true, the link doesn't have a rel="nofollow" attribute

            page_from_schemestring

url scheme of the referring page

            page_to_schemestring

url scheme of the referenced page

            directionstring

direction of the link
possible values: internal, external

            is_brokenboolean

link is broken
indicates whether a link is directing to a broken page or resource

            is_link_relation_conflictboolean

indicates that the link may have a conflict with another link
if true, at least one link pointing to link_to has a rel="nofollow" attribute and at least one is dofollow

            page_to_status_codeinteger

status code of the referenced page
status code of the page to which the link is pointing

            redirect_linkobject
            typestring

type of the link = 'redirect'
HTTP redirect with 3xx status code

            domain_fromstring

referring domain
the link was found on this domain

            domain_tostring

referenced domain
the link is pointing to this domain

            page_fromstring

referring page
relative URL of the page on which the link was found

            page_tostring

referenced page
relative URL of the page to which the link is pointing

            link_fromstring

referring page
absolute URL of the page on which the link was found

            link_tostring

referenced page
absolute URL of the page to which the link is pointing

            dofollowboolean

indicates whether the link is dofollow
if the value is true, the link doesn't have a rel="nofollow" attribute

            page_from_schemestring

url scheme of the referring page

            page_to_schemestring

url scheme of the referenced page

            directionstring

direction of the link
possible values: internal, external

            is_brokenboolean

link is broken
indicates whether a link is directing to a broken page or resource

            is_link_relation_conflictboolean

indicates that the link may have a conflict with another link
if true, at least one link pointing to link_to has a rel="nofollow" attribute and at least one is dofollow

            page_to_status_codeinteger

status code of the referenced page
status code of the page to which the link is pointing

‌‌

Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/on_page/links" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
  {
    "id": "07281559-0695-0216-0000-c269be8b7592",
    "page_from": "/apis/google-trends-api",
    "filters": [
      ["dofollow", "=", true],
      "and",
      ["direction", "=", "external"]
    ],
    "limit": 10
  }
]'
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
$client = new RestClient($api_url, null, 'login', 'password');

$post_array = array();
// simple way to get a result
$post_array[] = array(
   "id" => "07281559-0695-0216-0000-c269be8b7592",
   "page_from" => "/apis/google-trends-api",
   "filters" => [
      ["dofollow", "=", true],
      "and",
      ["direction", "=", "external"]
   ],
   "limit" => 10
);
try {
   // POST /v3/on_page/links
   // the full list of possible parameters is available in documentation
   $result = $client->post('/v3/on_page/links', $post_array);
   print_r($result);
   // do something with post result
} catch (RestClientException $e) {
   echo "n";
   print "HTTP code: {$e->getHttpCode()}n";
   print "Error code: {$e->getCode()}n";
   print "Message: {$e->getMessage()}n";
   print  $e->getTraceAsString();
   echo "n";
}
$client = null;
?>
const post_array = [];

post_array.push({
  "id": "07281559-0695-0216-0000-c269be8b7592",
  "page_from": "/apis/google-trends-api",
  "filters": [
    ["dofollow", "=", true],
    "and",
    ["direction", "=", "external"]
  ],
  "limit": 10
});

const axios = require('axios');

axios({
  method: 'post',
  url: 'https://api.dataforseo.com/v3/on_page/links',
  auth: {
    username: 'login',
    password: 'password'
  },
  data: post_array,
  headers: {
    'content-type': 'application/json'
  }
}).then(function (response) {
  var result = response['data']['tasks'];
  // Result data
  console.log(result);
}).catch(function (error) {
  console.log(error);
});
from random import Random
from client import RestClient
# You can download this file from here https://api.dataforseo.com/v3/_examples/python/_python_Client.zip
client = RestClient("login", "password")

post_data = dict()
# simple way to get a result
post_data[len(post_data)] = dict(
    id="07281559-0695-0216-0000-c269be8b7592",
    page_from="/apis/google-trends-api",
    filters=[
        ["dofollow", "=", True],
        "and", 
        ["direction", "=", "external"]
    ],
    limit=10
)
# POST /v3/on_page/links
# the full list of possible parameters is available in documentation
response = client.post("/v3/on_page/links", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace DataForSeoDemos
{
    public static partial class Demos
    {
        public static async Task on_page_links()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            // simple way to get a result
            postData.Add(new
            {
                id = "07281559-0695-0216-0000-c269be8b7592",
                page_from = "/apis/google-trends-api",
                filters = new object[]
                {
                    new object[] { "dofollow", "=", true },
                    "and",
                    new object[] { "direction", "=", "external" }
                },
                limit = 10
            });
            // POST /v3/on_page/links
            // the full list of possible parameters is available in documentation
            var taskPostResponse = await httpClient.PostAsync("/v3/on_page/links", new StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject<dynamic>(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}

The above command returns JSON structured like this:

{
  "version": "0.1.20201117",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "0.1513 sec.",
  "cost": 0,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "11301131-1535-0216-0000-014c8e8501d3",
      "status_code": 20000,
      "status_message": "Ok.",
      "time": "0.0737 sec.",
      "cost": 0,
      "result_count": 1,
      "path": [
        "v3",
        "on_page",
        "links"
      ],
      "data": {
        "api": "on_page",
        "function": "links",
        "page_from": "/apis/google-trends-api",
        "limit": 10
      },
      "result": [
        {
          "crawl_progress": "finished",
          "crawl_status": {
            "max_crawl_pages": 10,
            "pages_in_queue": 0,
            "pages_crawled": 10
          },
          "total_items_count": 15,
          "items_count": 10,
          "items": [
            {
              "type": "image",
              "domain_from": "dataforseo.com",
              "domain_to": "www.woorank.com",
              "page_from": "/apis/google-trends-api",
              "page_to": "/",
              "link_from": "https://dataforseo.com/apis/google-trends-api",
              "link_to": "https://www.woorank.com/",
              "link_attribute": null,
              "dofollow": true,
              "page_from_scheme": "https",
              "page_to_scheme": "https",
              "direction": "external",
              "is_broken": false,
              "text": null,
              "image_alt": "4-client",
              "image_src": "https://dataforseo.com/wp-content/uploads/2020/03/4-client-new-no-color.png",
              "is_link_relation_conflict": false,
              "page_to_status_code": null
            },
            {
              "type": "anchor",
              "domain_from": "dataforseo.com",
              "domain_to": "dataforseo.com",
              "page_from": "/apis/google-trends-api",
              "page_to": "/apis/keyword-data-api",
              "link_from": "https://dataforseo.com/apis/google-trends-api",
              "link_to": "https://dataforseo.com/apis/keyword-data-api",
              "link_attribute": null,
              "dofollow": true,
              "page_from_scheme": "https",
              "page_to_scheme": "https",
              "direction": "internal",
              "is_broken": false,
              "text": "Keyword Data API",
              "is_link_relation_conflict": false,
              "page_to_status_code": null
            },
            {
              "type": "image",
              "domain_from": "dataforseo.com",
              "domain_to": "longtailux.com",
              "page_from": "/apis/google-trends-api",
              "page_to": "/",
              "link_from": "https://dataforseo.com/apis/google-trends-api",
              "link_to": "https://longtailux.com/",
              "link_attribute": null,
              "dofollow": true,
              "page_from_scheme": "https",
              "page_to_scheme": "https",
              "direction": "external",
              "is_broken": false,
              "text": null,
              "image_alt": "8-client",
              "image_src": "https://dataforseo.com/wp-content/uploads/2020/03/8-client-new-no-color.png",
              "is_link_relation_conflict": false,
              "page_to_status_code": null
            },
            {
              "type": "anchor",
              "domain_from": "dataforseo.com",
              "domain_to": "dataforseo.com",
              "page_from": "/apis/google-trends-api",
              "page_to": "/apis/dataforseo-labs-api",
              "link_from": "https://dataforseo.com/apis/google-trends-api",
              "link_to": "https://dataforseo.com/apis/dataforseo-labs-api",
              "link_attribute": null,
              "dofollow": true,
              "page_from_scheme": "https",
              "page_to_scheme": "https",
              "direction": "internal",
              "is_broken": false,
              "text": "DataForSEO Labs API",
              "is_link_relation_conflict": false,
              "page_to_status_code": null
            },
            {
              "type": "image",
              "domain_from": "dataforseo.com",
              "domain_to": "neilpatel.com",
              "page_from": "/apis/google-trends-api",
              "page_to": "/",
              "link_from": "https://dataforseo.com/apis/google-trends-api",
              "link_to": "https://neilpatel.com/",
              "link_attribute": null,
              "dofollow": true,
              "page_from_scheme": "https",
              "page_to_scheme": "https",
              "direction": "external",
              "is_broken": false,
              "text": null,
              "image_alt": "1-client",
              "image_src": "https://dataforseo.com/wp-content/uploads/2020/03/1-client-new-no-color.png",
              "is_link_relation_conflict": false,
              "page_to_status_code": null
            },
            {
              "type": "alternate",
              "is_valid_hreflang": true,
              "hreflang": "en-US",				
              "domain_from": "dataforseo.com",
              "domain_to": "dataforseo.com",
              "page_from": "/apis/google-trends-api",
              "page_to": "/wp-json/oembed/1.0/embed?url=https://dataforseo.com/apis/google-trends-api&format=xml",
              "link_from": "https://dataforseo.com/apis/google-trends-api",
              "link_to": "https://dataforseo.com/wp-json/oembed/1.0/embed?url=https://dataforseo.com/apis/google-trends-api&format=xml",
              "dofollow": true,
              "page_from_scheme": "https",
              "page_to_scheme": "https",
              "direction": "internal",
              "is_broken": false,
              "is_link_relation_conflict": false,
              "page_to_status_code": null
            },
            {
              "type": "image",
              "domain_from": "dataforseo.com",
              "domain_to": "www.ignitur.com",
              "page_from": "/apis/google-trends-api",
              "page_to": "/",
              "link_from": "https://dataforseo.com/apis/google-trends-api",
              "link_to": "https://www.ignitur.com/",
              "link_attribute": null,
              "dofollow": true,
              "page_from_scheme": "https",
              "page_to_scheme": "https",
              "direction": "external",
              "is_broken": false,
              "text": null,
              "image_alt": "5-client",
              "image_src": "https://dataforseo.com/wp-content/uploads/2020/03/5-client-new-no-color.png",
              "is_link_relation_conflict": false,
              "page_to_status_code": null
            },
            {
              "type": "anchor",
              "domain_from": "dataforseo.com",
              "domain_to": "dataforseo.com",
              "page_from": "/apis/google-trends-api",
              "page_to": "/apis/google-ads-api",
              "link_from": "https://dataforseo.com/apis/google-trends-api",
              "link_to": "https://dataforseo.com/apis/google-ads-api",
              "link_attribute": null,
              "dofollow": true,
              "page_from_scheme": "https",
              "page_to_scheme": "https",
              "direction": "internal",
              "is_broken": false,
              "text": "Google Ads",
              "is_link_relation_conflict": false,
              "page_to_status_code": null
            },
            {
              "type": "image",
              "domain_from": "dataforseo.com",
              "domain_to": "agencyanalytics.com",
              "page_from": "/apis/google-trends-api",
              "page_to": "/",
              "link_from": "https://dataforseo.com/apis/google-trends-api",
              "link_to": "https://agencyanalytics.com/",
              "link_attribute": null,
              "dofollow": true,
              "page_from_scheme": "https",
              "page_to_scheme": "https",
              "direction": "external",
              "is_broken": false,
              "text": null,
              "image_alt": "7-client",
              "image_src": "https://dataforseo.com/wp-content/uploads/2020/03/7-client-new-no-color.png",
              "is_link_relation_conflict": false,
              "page_to_status_code": null
            },
            {
              "type": "anchor",
              "domain_from": "dataforseo.com",
              "domain_to": "dataforseo.com",
              "page_from": "/apis/google-trends-api",
              "page_to": "/apis/on-page-api",
              "link_from": "https://dataforseo.com/apis/google-trends-api",
              "link_to": "https://dataforseo.com/apis/on-page-api",
              "link_attribute": null,
              "dofollow": true,
              "page_from_scheme": "https",
              "page_to_scheme": "https",
              "direction": "internal",
              "is_broken": false,
              "text": "On-Page API",
              "is_link_relation_conflict": false,
              "page_to_status_code": null

            }
          ]
        }
      ]
    }
  ]
}